/* bresulti.c Stefan Spaennare Feb 98 */

/*****************************************************************************/
/*                                                                           */
/* Notice:                                                                   */
/* =======                                                                   */
/*                                                                           */
/* I make no warranties that this program is (1) free of error, (2) con-     */
/* sistent with any standard merchantability, or (3) meeting the require-    */
/* ments of a particular application.  This software shall not, partly or    */
/* as a whole, participate in a process, whose outcome can result in injury  */
/* to a person or loss of property. It is solely designed for analytical     */
/* work.  Permission to use, copy, and distribute is hereby granted without  */
/* fee, providing that the header above including this notice appears in     */
/* all copies.                                                               */
/*                                                                           */
/*                                                         Stefan Spaennare  */
/*                                                                           */
/*****************************************************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>

void getrow(infile,ss)
FILE *infile;
char *ss;
{
   int j;
   char c;

   if ((c = getc(infile)) != EOF) {
      ss[0]=c;
      j=1;
      if (c != '\n') {
         while ((c = getc(infile)) != '\n') {
            ss[j]=c;
            j++;
         } /* while */
      } /* if */
      ss[j]='\0';
   } /* if */

} /* getrow */


int main(argc,argv)
int argc;
char *argv[];

{
   
   FILE *infile;

   int i,j,n,t1,t2;

   double meani,meanf,sum,temp,base;

   char c;
   char ss[257];
   char ss2[21];
   char ss3[21];
   char ss4[21];
   char ss5[21];
   char ss6[21];

   double vi[9];
   double vri[9];


   if (argc < 2) {
      printf("Usage: %s timesifile\n",argv[0]);
      exit(0);
   } /* if */
   

   if ((infile = fopen(argv[1],"r")) == NULL) {
      printf("File not found.\n");
      exit(0);
   } /* if */

   for (i=1; i<=3; i++) {
      getrow(infile,ss);
   } /* for i */

   fscanf(infile,"%s %s %s %s %lf %s",ss2,ss3,ss4,ss5,&vi[1],ss6);

   for (i=1; i<=123; i++) {
      getrow(infile,ss);
   } /* for i */

   fscanf(infile,"%lf",&vi[2]);

   for (i=1; i<=5; i++) {
      getrow(infile,ss);
   } /* for i */

   fscanf(infile,"%lf",&vi[3]);

   for (i=1; i<=2; i++) {
      getrow(infile,ss);
   } /* for i */

   fscanf(infile,"%lf",&vi[4]);

   for (i=1; i<=2; i++) {
      getrow(infile,ss);
   } /* for i */

   fscanf(infile,"%lf",&vi[5]);

   for (i=1; i<=0; i++) {
      getrow(infile,ss);
   } /* for i */


   fscanf(infile,"%d %d %lf",&t1,&t2,&vi[6]);

   fscanf(infile,"%lf",&vi[7]);

   for (i=1; i<=10; i++) {
      getrow(infile,ss);
   } /* for i */

   fscanf(infile,"%s %s %lf %s",ss2,ss3,&vi[8],ss4);



   vri[1]=1.0;
   vri[2]=1.0;
   vri[3]=1.0;
   vri[4]=1.0;
   vri[5]=1.0;
   vri[6]=1.0;
   vri[7]=1.0;
   vri[8]=1.0;

   meani=1.0;
   sum=0.0;

   for (i=1; i<=8; i++) {
      temp=vi[i]/vri[i];
      sum=sum+temp;
      meani=meani*temp;
   } /* for i */

   meani=exp(log(meani)/8.0);

   base=1000.0;

   printf("\n");
   printf("SSBENCH: Integer CPU Benchmark Result\n");
   printf("=====================================\n");

   printf("\n");
   printf("   Program        CPU-time       SIint\n");
   printf("--------------------------------------\n");
   printf("1: Yahtzee:     %9.2f s %9.2f\n",vi[1],base/vi[1]);
   printf("2: Coin:        %9.2f s %9.2f\n",vi[2],base/vi[2]);
   printf("3: Esift2:      %9.2f s %9.2f\n",vi[3],base/vi[3]);
   printf("4: Primes2:     %9.2f s %9.2f\n",vi[4],base/vi[4]);
   printf("5: Primm2:      %9.2f s %9.2f\n",vi[5],base/vi[5]);
   printf("6: Queens2:     %9.2f s %9.2f\n",vi[6],base/vi[6]);
   printf("7: Medianhs2:   %9.2f s %9.2f\n",vi[7],base/vi[7]);
   printf("8: Ssei:        %9.2f s %9.2f\n",vi[8],base/vi[8]);
   printf("--------------------------------------\n");

   printf("I geom mean:    %9.2f s %9.2f\n",meani,base/meani);

   printf("--------------------------------------\n");
   printf("Time total:     %9.2f s\n",sum);
   printf("--------------------------------------\n");
   printf("\n");


} /* End */
